.. cordic_dds documentation

.. This file is protected by Copyright. Please refer to the COPYRIGHT file
   distributed with this source distribution.

   This file is part of OpenCPI <http://www.opencpi.org>

   OpenCPI is free software: you can redistribute it and/or modify it under the
   terms of the GNU Lesser General Public License as published by the Free
   Software Foundation, either version 3 of the License, or (at your option) any
   later version.

   OpenCPI is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
   A PARTICULAR PURPOSE. See the GNU Lesser General Public License for
   more details.

   You should have received a copy of the GNU Lesser General Public License
   along with this program. If not, see <http://www.gnu.org/licenses/>.


.. meta::
   :keywords: sinusoidal wave trigonometry


.. _cordic_dds-primitive:


CORDIC DDS (``cordic_dds``)
===========================
Generates sine and cosine signals at a user definable frequency and amplitude.

Design
------
This direct digital synthesis (DDS) primitive uses the coordinate rotation digital computer (CORDIC) algorithm. For more details on the CORDIC algorithm see :ref:`cordic_sin_cos-primitive`.

A phase accumulator is used to keep track of the phase of sine and cosine signals. The phase accumulator adds a definable value (``step_size``) to the previous phase value. When full the phase accumulator will overflow and wrap round. The phase value stored in the phase accumulator is fed into the ``angle_in`` input of the ``cordic_sin_cos`` primitive. This module calculates the cosine and sine values for the input phase angle.

The phase accumulator size is user definable using the ``phase_accum_size_g`` generic. It must be at least 32 bits (when using the default CORDIC look-up table in the ``cordic_sin_cos`` primitive). A larger phase accumulator lets the frequency be set more accurately. The frequency resolution is given by :math:`\frac{\text{sample_rate}}{2^{\texttt{phase_accum_size_g}}}`. If the phase accumulator is greater than 32 bits wide then the phase accumulator value is truncated before it is sent to the ``cordic_sin_cos`` module. The output resolution still increases but a small amount of phase noise is added.

The output frequency of the sine and cosine waves generated by the module depends on the sampling rate of the system. If this is known then ``step_size`` for a desired output frequency is given by :eq:`cordic_dds_freq-equation`.

.. math::
   :label: cordic_dds_freq-equation

   \delta = \frac{f*2^{\texttt{phase_accum_size_g}}}{R_s}

In :eq:`cordic_dds_freq-equation`:

 * :math:`\delta` is the step size.

 * :math:`f` is the output frequency

 * :math:`R_s` is the sample rate.

Implementation
--------------
The module is fully pipelined meaning that after a fixed latency a new output value is generated every clock cycle. The latency is set by the number of stages in the CORDIC pipeline in the ``cordic_sin_cos`` primitive. The number of pipeline stages and thus the latency is set by the ``output_size_g`` generic. This means that if the step ``size_size`` or ``gain_in`` inputs are changed the ``sine_out`` or ``cosine_out`` outputs will reflect these changes after ``output_size_g`` clock cycles.

The module has a clock enable signal that allows it to be disabled while retaining the contents of the CORDIC pipeline.

The cosine and sine outputs can be treated as the real and imaginary elements of a complex sine wave.

Interface
---------

Generics
~~~~~~~~

 * ``phase_accum_size_g`` (``integer``): Phase accumulator size. Minimum 32 bits, unless ``cordic_sin_cos`` look-up table changed.

 * ``output_width_g`` (``integer``): Output bit size. Maximum 32 bits, unless ``cordic_sin_cos`` look-up table changed.

Ports
~~~~~

 * ``clk`` (``std_logic``), in: Clock. Inputs and outputs registered on rising edge.

 * ``rst`` (``std_logic``), in: Reset. Active high, synchronous with rising edge of clock.

 * ``clk_enable`` (``std_logic``), in: Enable. If ``enable`` is low the module will not operate.

 * ``step_size`` (``std_logic_vector``, ``phase_accum_size_g-1`` bits, signed), in: Sets the DDS step size. ``step_size`` can be set to a specific frequency using :eq:`cordic_dds_freq-equation`.

 * ``gain_in`` (``std_logic_vector``, ``output_width_g-1`` bits), in: Sets the amplitude of the sine and cosine outputs. :math:`\texttt{gain_in} = \left \lfloor \frac{\text{desired_amplitude}}{1.646760258} \right \rfloor`

 * ``sine_out`` (``std_logic_vector``, ``output_width_g-1`` bits, signed), out: The sine output of the module.

 * ``cosine_out`` (``std_logic_vector``, ``output_width_g-1`` bits, signed), out: The cosine output of the module.

Dependencies
------------
The dependencies to other elements in OpenCPI are:

 * :ref:`cordic_sin_cos primitive <cordic_sin_cos-primitive>`

There is also a dependency on:

 * ``ieee.std_logic_1164``

 * ``ieee.numeric_std``

Limitations
-----------
Limitations of ``cordic_dds`` are:

When the desired amplitude is full scale (for a given output width) then care must be taken to avoid overflows. Overflows can occur due to small inaccuracies in the CORDIC calculations.

For example with a 16 bit output setting ``gain_in`` to :math:`\left \lfloor \frac{2^{15} - 1}{1.646760258} \right \rfloor = 19897`, this would likely mean that some sine or cosine values would be one or two counts above 32767 (or below -32768) causing an overflow. Instead the ``gain_in`` input should be set so that the final output scale is several counts below full scale. The table below shows recommended gain values to achieve (as close as possible) a full scale output.

+--------------+------------------------------------+
| Output width | ``gain_in`` setting for full scale |
+==============+====================================+
| 12 bits      | 1240                               |
+--------------+------------------------------------+
| 16 bits      | 19872                              |
+--------------+------------------------------------+
| 32 bits      | 1304065744                         |
+--------------+------------------------------------+
